/*
 * Copyright (c) 2018 - present.  Boling Consulting Solutions (bcsw.net)
 * Copyright 2020-present Open Networking Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * NOTE: This file was generated, manual edits will be overwritten!
 *
 * Generated by 'goCodeGenerator.py':
 *              https://github.com/cboling/OMCI-parser/README.md
 */

package generated

import "github.com/deckarep/golang-set"

// EfmBondingGroupPerformanceMonitoringHistoryDataPart2ClassID is the 16-bit ID for the OMCI
// Managed entity EFM bonding group performance monitoring history data part 2
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2ClassID = ClassID(421) // 0x01a5

var efmbondinggroupperformancemonitoringhistorydatapart2BME *ManagedEntityDefinition

// EfmBondingGroupPerformanceMonitoringHistoryDataPart2 (Class ID: #421 / 0x01a5)
//	This ME collects PM data as seen at the xTU-C. Instances of this ME are created and deleted by
//	the OLT.
//
//	Relationships
//		An instance of this ME is associated with an xDSL UNI.
//
//	Attributes
//		Managed Entity Id
//			This attribute uniquely identifies each instance of this ME. Through an identical ID, this ME is
//			implicitly linked to an instance of the EFM bonding group. (R, setbycreate) (mandatory)
//			(2-bytes)
//
//		Interval End Time
//			This attribute identifies the most recently finished 15-min interval. (R) (mandatory) (1-byte)
//
//		Threshold Data 1_2 Id
//			Threshold data 1/2 ID: This attribute points to an instance of the threshold data 1 and 2 MEs
//			that contain PM threshold values. (R,-W, setbycreate) (mandatory) (2-bytes)
//
//		Rx Unicast Frames
//			Number of unicast Ethernet frames received over this group. (R) (mandatory) (4-bytes)
//
//		Tx Unicast Frames
//			Number of unicast Ethernet frames transmitted over this group. (R) (mandatory) (4-bytes)
//
//		Rx Unicast Bytes
//			Number of bytes contained in the unicast Ethernet frames received over this group. (R)
//			(mandatory) (8-bytes)
//
//		Tx Unicast Bytes
//			Number of bytes contained in the unicast Ethernet frames transmitted over this group. (R)
//			(mandatory) (8-bytes)
//
//		Rx Broadcast Frames
//			Number of broadcast Ethernet frames received over this group. (R) (mandatory) (4-bytes)
//
//		Tx Broadcast Frames
//			Number of broadcast Ethernet frames transmitted over this group. (R) (mandatory) (4-bytes)
//
//		Rx Broadcast Bytes
//			Number of bytes contained in the broadcast Ethernet frames received over this group. (R)
//			(mandatory) (8-bytes)
//
//		Tx Broadcast Bytes
//			Number of bytes contained in the broadcast Ethernet frames transmitted over this group. (R)
//			(mandatory) (8-bytes)
//
//		Rx Multicast Frames
//			Number of multicast Ethernet frames received over this group. (R) (mandatory) (4-bytes)
//
//		Tx Multicast Frames
//			Number of multicast Ethernet frames transmitted over this group. (R) (mandatory) (4-bytes)
//
//		Rx Multicast Bytes
//			Number of bytes contained in the multicast Ethernet frames received over this group. (R)
//			(mandatory) (8-bytes)
//
//		Tx Multicast Bytes
//			Number of bytes contained in the multicast Ethernet frames transmitted over this group. (R)
//			(mandatory) (8-bytes)
//
type EfmBondingGroupPerformanceMonitoringHistoryDataPart2 struct {
	ManagedEntityDefinition
	Attributes AttributeValueMap
}

// Attribute name constants

const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_IntervalEndTime = "IntervalEndTime"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_ThresholdData12Id = "ThresholdData12Id"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxUnicastFrames = "RxUnicastFrames"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxUnicastFrames = "TxUnicastFrames"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxUnicastBytes = "RxUnicastBytes"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxUnicastBytes = "TxUnicastBytes"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxBroadcastFrames = "RxBroadcastFrames"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxBroadcastFrames = "TxBroadcastFrames"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxBroadcastBytes = "RxBroadcastBytes"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxBroadcastBytes = "TxBroadcastBytes"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxMulticastFrames = "RxMulticastFrames"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxMulticastFrames = "TxMulticastFrames"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxMulticastBytes = "RxMulticastBytes"
const EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxMulticastBytes = "TxMulticastBytes"

func init() {
	efmbondinggroupperformancemonitoringhistorydatapart2BME = &ManagedEntityDefinition{
		Name:    "EfmBondingGroupPerformanceMonitoringHistoryDataPart2",
		ClassID: EfmBondingGroupPerformanceMonitoringHistoryDataPart2ClassID,
		MessageTypes: mapset.NewSetWith(
			Create,
			Delete,
			Get,
			Set,
			GetCurrentData,
		),
		AllowedAttributeMask: 0xfffc,
		AttributeDefinitions: AttributeDefinitionMap{
			0:  Uint16Field(ManagedEntityID, PointerAttributeType, 0x0000, 0, mapset.NewSetWith(Read, SetByCreate), false, false, false, 0),
			1:  ByteField(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_IntervalEndTime, UnsignedIntegerAttributeType, 0x8000, 0, mapset.NewSetWith(Read), false, false, false, 1),
			2:  Uint16Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_ThresholdData12Id, UnsignedIntegerAttributeType, 0x4000, 0, mapset.NewSetWith(Read, SetByCreate, Write), false, false, false, 2),
			3:  Uint32Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxUnicastFrames, CounterAttributeType, 0x2000, 0, mapset.NewSetWith(Read), false, false, false, 3),
			4:  Uint32Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxUnicastFrames, CounterAttributeType, 0x1000, 0, mapset.NewSetWith(Read), false, false, false, 4),
			5:  Uint64Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxUnicastBytes, CounterAttributeType, 0x0800, 0, mapset.NewSetWith(Read), false, false, false, 5),
			6:  Uint64Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxUnicastBytes, CounterAttributeType, 0x0400, 0, mapset.NewSetWith(Read), false, false, false, 6),
			7:  Uint32Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxBroadcastFrames, CounterAttributeType, 0x0200, 0, mapset.NewSetWith(Read), false, false, false, 7),
			8:  Uint32Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxBroadcastFrames, CounterAttributeType, 0x0100, 0, mapset.NewSetWith(Read), false, false, false, 8),
			9:  Uint64Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxBroadcastBytes, CounterAttributeType, 0x0080, 0, mapset.NewSetWith(Read), false, false, false, 9),
			10: Uint64Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxBroadcastBytes, CounterAttributeType, 0x0040, 0, mapset.NewSetWith(Read), false, false, false, 10),
			11: Uint32Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxMulticastFrames, CounterAttributeType, 0x0020, 0, mapset.NewSetWith(Read), false, false, false, 11),
			12: Uint32Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxMulticastFrames, CounterAttributeType, 0x0010, 0, mapset.NewSetWith(Read), false, false, false, 12),
			13: Uint64Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_RxMulticastBytes, CounterAttributeType, 0x0008, 0, mapset.NewSetWith(Read), false, false, false, 13),
			14: Uint64Field(EfmBondingGroupPerformanceMonitoringHistoryDataPart2_TxMulticastBytes, CounterAttributeType, 0x0004, 0, mapset.NewSetWith(Read), false, false, false, 14),
		},
		Access:  CreatedByOlt,
		Support: UnknownSupport,
	}
}

// NewEfmBondingGroupPerformanceMonitoringHistoryDataPart2 (class ID 421) creates the basic
// Managed Entity definition that is used to validate an ME of this type that
// is received from or transmitted to the OMCC.
func NewEfmBondingGroupPerformanceMonitoringHistoryDataPart2(params ...ParamData) (*ManagedEntity, OmciErrors) {
	return NewManagedEntity(*efmbondinggroupperformancemonitoringhistorydatapart2BME, params...)
}
